import java.awt.*;
import java.awt.event.*;
import java.awt.font.*;
import java.awt.print.*;
import java.io.*;

class TextViewer
{
	public static void main(String args[])
	{
		new MainWindow();
	}
}

class MainWindow extends Frame
{
	// s̎擾
	final String line_separator = System.getProperty("line.separator");

	// eLXgGA
	TextArea text_view;

	// t@C̍s
	int num_line;

	public MainWindow()
	{
		super("Text Viewer");

		// EChEXi̒ǉ
		WindowListener listener = new WindowAdapter()
		{
			public void windowClosing(WindowEvent e)
			{
				System.exit(0);
			}
		};
		addWindowListener(listener);

		// j[o[
		MenuBar mb = new MenuBar();

		// Filej[`
		Menu file = new Menu("File");
		MenuItem item_open = new MenuItem("Open");
		MenuItem item_print = new MenuItem("Print");
		MenuItem item_exit = new MenuItem("Exit");

		file.add(item_open);
		file.add(item_print);
		file.addSeparator();
		file.add(item_exit);

		// File->OpenR}h`
		item_open.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				// t@CI[v_CAO̕\
				FileDialog dialog = new FileDialog(MainWindow.this,"File Load",FileDialog.LOAD);
				dialog.show();

				try
				{
					// t@C̓ǂݍ
					FileInputStream file_in = new FileInputStream(dialog.getDirectory() + dialog.getFile());
					BufferedReader reader = new BufferedReader(new InputStreamReader(file_in));

					String buffer;
					text_view.setText("");
					num_line = 0;
					while((buffer = reader.readLine()) != null)
					{
						// eLXgGAփZbg
						text_view.append(buffer + line_separator);
						num_line++;
					}
				}
				catch(IOException ioe)
				{
					System.err.println(ioe);
				}
			}
		});

		// File->PrintR}h`
		item_print.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				// v^[Wu̍\z
				PrinterJob printer = PrinterJob.getPrinterJob();
				PageFormat format = printer.defaultPage();
				printer.setPrintable(new TextPrinter(text_view.getText(),num_line));

				// v^ݒ_CAO̕\
				if(printer.printDialog())
				{
					try
					{
						// 
						printer.print();
					}
					catch(PrinterException pe)
					{
						System.err.println(pe);
					}
				}
			}
		});

		// File->ExitR}h`
		item_exit.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				System.exit(0);
			}
		});

		// j[o[Filej[̒ǉ
		mb.add(file);

		// eLXgGÃZbg
		text_view = new TextArea();
		add(text_view,BorderLayout.CENTER);

		// j[o[̃Zbg
		setMenuBar(mb);

		// EChE̕\
		pack();
		setVisible(true);
	}
}

class TextPrinter implements Printable
{
	// eLXg
	String text,text_lines[];

	// y[Ẅs
	final int MAX_LINES_OF_PAGE = 35;

	// ^ũXy[Xg
	final int TAB_TO_SPACE = 4;

	// t@C̍s
	int num_line;

	String line_separator = System.getProperty("line.separator");

	// RXgN^
	public TextPrinter(String text,int num_line)
	{
		super();

		this.text = text;
		this.num_line = num_line;
	}

	// \bh
	public int print(Graphics g,PageFormat format,int page_index)
	{
		// eLXg̎擾
		text_lines = new String[num_line + 1];
		int index = 0,pre_index = 0,line = 0;

		while((index = text.indexOf(line_separator,index)) != -1)
		{
			text_lines[line] = expandTab(text.substring(pre_index,index),TAB_TO_SPACE);
			pre_index = ++index;
			line++;
		}

		// 
		int return_code;

		if(num_line >= MAX_LINES_OF_PAGE)
		{
			return_code = TextPrint(g,format,page_index,MAX_LINES_OF_PAGE);
		}
		else
		{
			return_code = TextPrint(g,format,page_index,num_line);
		}

		return(return_code);
	}

	// eLXg
	protected int TextPrint(Graphics g,PageFormat format,int page_index,int num_line_of_page)
	{
		// Graphics2D̍\z
		Graphics g2d = (Graphics2D)g;

		// Font̎擾
		Font font = g.getFont();
		LineMetrics font_info = font.getLineMetrics(text,new FontRenderContext(font.getTransform(),false,false));
		float font_height = font_info.getHeight();
		float font_leading = font_info.getLeading();

		// \̈̎擾
		float offsetX = (float)format.getImageableX();
		float offsetY = (float)format.getImageableY();

		// \y[W̐ݒ
		if(page_index >= 5)
		{
			// 
			return(Printable.NO_SUCH_PAGE);
		}

		// vf̐ݒ
		g2d.setFont(new Font("Dialog",Font.PLAIN,12));
		g2d.setColor(Color.black);

		for(int i=1;i<=num_line_of_page;i++)
		{
			int current_line = page_index * MAX_LINES_OF_PAGE + i - 1;
			float x_coodinate = offsetX;
			float y_coodinate = offsetY + i * (font_height + font_leading);
			g2d.drawString(text_lines[current_line],(int)x_coodinate,(int)y_coodinate);
		}

		// 퉞
		return(Printable.PAGE_EXISTS);
	}

	// ^ug\bh(ex.1̃^u->4̃Xy[X)
	protected String expandTab(String src,int num_space)
	{
		// w萔̃Xy[Xׂ
		StringBuffer space = new StringBuffer();
		for(int i=0;i<num_space;i++)
		{
			space.append(' ');
		}

		// u
		StringBuffer buffer = new StringBuffer();
		for(int i=0;i<src.length();i++)
		{
			if(src.charAt(i) == '\t')
			{
				buffer.append(space);
			}
			else
			{
				buffer.append(src.charAt(i));
			}
		}

		return(buffer.toString());
	}
}